## Overview

GitLab auto-deploy deployments allow us to increase the frequency
of deployments to GitLab.com from the master branch of
[gitlab], [gitaly],
and [omnibus-gitlab].

This process is a shift from the previous monthly release cycle for GitLab.com where
there was a code freeze on the 7th of the month.

Current terminology and the release cadence for all types of release are in the
[releases handbook page].

## Process overview

### Auto-deploy branches

At a cadence defined in the [releases handbook page], up until the release date on the 22nd, auto-deploy
branches are created with the following format:

```
<MAJOR>-<MINOR>-auto-deploy-<TIMESTAMP>
```

example: `11-10-auto-deploy-20190702`

* `MAJOR.MINOR`: This comes from the currently active milestone on the [gitlab
  project][gitlab]. It generally tracks to the release month and has the following
  requirements:
  * It must be an _active_ milestone
  * The start date must be in the _past_
  * The end date must be in the _future_
* `TIMESTAMP`: The day the branch was created, in `YYYYmmdd` format.

Auto-deploy branches are created for the following projects:

* [gitlab](https://gitlab.com/gitlab-org/gitlab/)
* [omnibus-gitlab](https://gitlab.com/gitlab-org/omnibus-gitlab)
* [CNG image](https://gitlab.com/gitlab-org/build/CNG/)
* [Helm chart](https://gitlab.com/gitlab-org/charts/gitlab/)

These branches are created from the latest commit on the `master` branch at
the moment of branch creation.

As soon as these branches are created, the latest green (passing) commit on the branch
will be tagged for an auto-deployment. This means that the HEAD of the auto-deploy
branch won't necessarily be the one that is a candidate for deployment.
This is done to ensure that we always deploy commits with some confidence.

Auto-deployment is driven by automated tasks in the [release-tools](https://gitlab.com/gitlab-org/release-tools/) project. Releases handbook page describes [how scheduled pipelines execute specific task](https://about.gitlab.com/handbook/engineering/releases/#gitlabcom-releases-1).

Auto-deploy branches are _protected branches_, meaning that they require special
permission for merging and pushing, and are also automatically mirrored to
dev.gitlab.org. The permissions for merging and pushing are only granted to the
release managers group.

### Auto-deploy tagging

For every deployment created using the auto-deploy process, there is a git tag
that matches the version of what is deployed. The auto-deploy tag varies
depending on the project for which is being tagged.

For:

* `omnibus-gitlab`
* `deployer`

It has the following format:

```
<MAJOR>.<MINOR>.<TIMESTAMP>+<gitlab sha>.<omnibus-gitlab sha>
```

For:

* `CNG`
* `charts/gitlab`

It has the following format:

```
<MAJOR>.<MINOR>.<TIMESTAMP>+<gitlab sha>
```

* `MAJOR.MINOR`: This is the currently active milestone in the `gitlab-org`
  group on gitlab.com and follows the same requirements
  for the auto-deploy branch (see above).
* `TIMESTAMP`: Timestamp of the commit in omnibus-gitlab project. This value is guaranteed to increment when a new commit is made in omnibus-gitlab, which will happen at minimum when something changes the GitLab Rails project.
* `gitlab sha`: The sha of gitlab for auto-deploy, it corresponds to a
  green (passing) commit on the gitlab auto-deploy branch.
* `omnibus-gitlab sha`: The sha of omnibus-gitlab that will be used for the next
  auto-deploy, it corresponds to a green (passing) ref on the omnibus-gitlab
  auto-deploy branch

The discrepancy between the auto-deploy tags, stems from iterating as we work
towards a much more refined method of maintaining version information across
all repos that contribute to a GitLab package, regardless of what builds that
package.  The progress for this work is to be tracked here:
https://gitlab.com/gitlab-com/gl-infra/delivery/issues/690

As mentioned previously, the omnibus-gitlab tag will trigger a deployment to a
non-production environment.

### Auto-deploy schedule

Using an example of a non existent release **11.12**, let's assume that a
milestone is created with a start date of the 23rd and a due date of the 22nd.

The table below gives an overview of the schedule:

<table>
<thead>
<tr>
<th>Day</th>
<th>Description</th>
</tr>
</thead>

<tr>
  <td>23rd</td>
  <td>

  * The **11.12** milestone is active.
  * An automated CI job creates a branch named **11-12-auto-deploy-20190702** in gitlab-foss, omnibus-gitlab and
    gitlab from the **master** branch.
    * The latest green commit of gitlab is used to update versions of GitLab
      services in the omnibus-gitlab repository.
    * The commits in gitlab and omnibus-gitlab are tagged with **11.12.201907021014+aaaa.ffff**.
    * The resulting auto-deploy package is deployed to staging and then
      production canary

  </td>
</tr>
<tr>
  <td>23rd..1st</td>
  <td>

  * In case an issue is discovered after deployment, one or many MRs need to be created resolving the issue.
  * MRs are reviewed and merged to the `master` branch using the regular process.
  * In order for the MR to be included in auto-deploy branch, a label **Pick into auto-deploy** needs to be applied. See [here](https://about.gitlab.com/handbook/engineering/releases/#gitlabcom-releases-2) for up-to-date information on how to ensure your MR is picked.
  * A CI job checks the MRs for auto-deploy
    * Labeled MRs are picked automatically into the **11-12-auto-deploy-20190723** branch
    * The merge train ensures that CE is merged into EE
    * MRs are updated with a comment to let the MR author know that the change has been prepped for next deployment.
  * The next green commit on the auto-deploy branch is tagged with **11.12.201907021014+bbbb.ffff**
    * The resulting auto-deploy package is deployed to staging, and then
      production canary
    * In case the latest green commit has already been deployed, no action is taken.
  * This process is repeated on a frequent interval, with multiple deployments
    to the staging and production canary environments
  * Other MRs (ones without the label) merged to the `master` branch are not included until the next week's
    auto-deploy branch, **11-12-auto-deploy-20190701**

  </td>
</tr>
<tr>
  <td>1st</td>
  <td>

  * Branch **11-12-auto-deploy-20190701** created in gitlab-foss, omnibus-gitlab and
    gitlab from the **master** branch.
  * The same automated process runs as explained above.
  * The same picking and deploying process is now done for the new auto-deploy
    branch, **11-12-auto-deploy-20190701**
  </td>
</tr>
<tr>
  <td>8th</td>
  <td>

  * Branch **11-12-auto-deploy-20190708** created in gitlab-foss, omnibus-gitlab and
    gitlab from **master**
  * The same picking and deploying process is now done for the new auto-deploy
    branch, **11-12-auto-deploy-20190708**

  </td>
</tr>
<tr>
  <td>15th</td>
  <td>

  * Branch **11-12-auto-deploy-20190715** created in gitlab-foss, omnibus-gitlab and
    gitlab from **master**
  * The same picking and deploying process is now done for the new auto-deploy
    branch, **11-12-auto-deploy-20190715**

  </td>
</tr>
<tr>
  <td>22nd RELEASE DAY</td>
  <td>

  * The commit that is currently deployed to production will be used for the official
    release.
  * Changes that are released on production will be part of the release blog
    post.
  * If the MR introducing a change is picked into **11-12-auto-deploy-00004** but not
    deployed to production, the change in question is not going to be included into the final
    self-managed release.
  * 11.12 is published.

  </td>
</tr>

<tr>
  <td>23rd</td>
  <td>

  * A new milestone, **11.13** is active with a start date of the 23rd and a due date of the 22nd
  * The process auto-deploy cycle repeats

  </td>
</tr>

</table>

General overview of the complete timeline is described in the [engineering handbook](https://about.gitlab.com/handbook/engineering/releases/#timelines).

### Auto-deploy status

We've created an `auto_deploy status` ChatOps command that can be used to see
the deployment status of all of our environments (staging, canary, production).

In #releases Slack channel:

```
/chatops run auto_deploy status
```

This command will output the version, revision, and auto-deploy branch of each
environment, if available.

#### Status of a merged MR or a commit

The Merge Request widget shows the environment and the time of deployment in every Merge Request.
This should provide sufficient information to understand where in the deployment
process any merge request is:

* `gprd` is production environment - GitLab.com
* `gprd-cny` is canary environment - canary.gitlab.com
* `gstg` is staging environment - staging.gitlab.com
* No environment in the widget means that the MR is not deployed to any environment yet

![MR widget](../images/mr-widget-deployment-status.png)

For GitLab team-members, you can provide the SHA of a commit to see which environment (if any) that commit has been deployed to by running the following
chatops command in Slack `#releases` channel:

```
/chatops run auto_deploy status c11d293537748555a0b64a371f7d72629b3dfe9e
```

This command will output information about the commit, as well as any
environments it's currently deployed to.

If you do not have access to ChatOps, see [how you can obtain access](https://docs.gitlab.com/ee/development/feature_flags/controls.html#access).

## FAQ

### How does this change the existing feature freeze on the 7th?

Throughout the growth of GitLab as a company, the feature freeze implied
creation of a `stable` branch which also meant that any fix would have to wait for the
next cycle, sometimes a full month after the initial release of a feature.

From the perspective of the release, the feature freeze becomes obsolete. Any change
introduced to the `master` branch will be deployed through the environments, and
will find its way to GitLab.com within a week (at least at the beginning)
after it has been merged.

### How often do we auto-deploy?

The automated pipelines are running on a 1 hour schedule and will create a new
auto-deploy pipeline that will extend from staging to the production canary
environment.  The promotion of the auto-deploy build to production is manual,
either through a GitLab Chatops command or a manual action on the pipeline.

The following two conditions *must* be met in order for an automatic deployment
to proceed to production canary:

* QA smoke tests must pass on the staging environment
* We must not be in a change-lock window, which is current configured for
  multiple periods in the [change-lock configuration file](https://gitlab.com/gitlab-com/gl-infra/change-lock/blob/master/config/changelock.yml).

Since the deployment pipeline only looks for a green (passing) CI build,
it is important that all changes merged to master also pass all CI tests
in the auto-deploy branch.

Example:

From the moment the automated cherry-picker leaves a message that the change is picked,
the CI pipeline will run for that specific commit in the branch. Depending on the time the
specs passed, the change might be deployed to the first non-production environment anywhere
from 3-6 hours.

*Note*: The frequency of the auto-deployment is set conservatively at the beginning while we measure the impact on environment stability as well as process transition. As we get more comfortable, the goal is to have even more frequent deployment to production environments.

### What about registry, workhorse, pages and other components?

All GitLab created components such as gitlab-workhorse, gitlab-pages and similar
have a `VERSION` file inside of the GitLab EE repository.
For the time being, this remains unchanged and these files are the source of truth for the deployment pipelines.

Components such as Registry have the version set inside of the omnibus-gitlab project,
and that is the source of truth for the deployment pipelines for the time being.

### What will happen with security patches?

Process for P1/S1 security patches remains the same.
Security patches included in the regular monthly security release will be deployed to GitLab.com prior to publishing by merging the changes into the `master` branch, and manually including them in the active auto-deploy branch.
This change will only affect release managers, developers and other process stakeholders won't have a process change for the time being.

### How do I mark an MR so that will be picked into the auto-deploy branch?

In most cases, you won't need to apply an additional label to your MR because your change will be deployed with the new auto-deploy branch after the MR has been merged.
Please refer to [the handbook](https://about.gitlab.com/handbook/engineering/releases/#gitlabcom-releases-2)
for the rules about applying the `Pick into auto-deploy` label.

In cases where the MR was not able to pick cleanly to the auto-deploy branch,
you will need to create a MR targeting the currently active auto-deploy branch and assign to all active release managers. The auto-deploy branch name will be posted in the comment
created by the cherry-pick bot.

### Does auto-deploy change how we release software to the self-managed users?

Yes and no.
The stable branches are created closer to the 22nd instead of the 7th, and the stable branches
become backport branches for any patch releases that needs to happen in future.
The self-managed users will still receive the next release on the 22nd
of the month and will receive patch releases as needed, as was the case up until now.

### How are auto-deploy branches different than the stable branch?

The auto-deploy branches are shorter lived and are created from the `master` branch more frequently.
You can consider any auto-deploy branch as a "slowed down" `master` branch
than a long running `stable` branch. The auto-deploy branches are intended to have a short lifespan.

### Why are we not deploying directly from the master branch?

The `master` branch receives a large number of changes daily. While we do have a large
test coverage covering individual pieces, end to end test coverage is still being improved.
We are also still lacking the large enough data set for developers to test their changes at scale
and number of issues are still discovered in staging or canary, and in some cases in production too.
By the time an issue is discovered, the `master` branch received hundreds of different changes and it is pretty
difficult to isolate the problem without introducing another one that would block further deployments.
Blocking deployments has a worse effect; once the deployments are enabled again we would be introducing an even larger data set. The auto-deploy branches are giving us some time to discover issues and fix them without the pressure.

### How do I query what ref is running on gitlab.com or one of the other environments?

On GitLab.com you can check the `/help` page when logged in and see the sha of deployed commit.
We will be adding methods of exposing the versions as we get the process in place.

### How will marketing teams know what features to put in the release blog post?

The release-post managers and product management will have to change the way the release blog post is created.
The release blog post will have to be composed of items that are deployed on GitLab.com as opposed to what was planned for delivery. Release on the 22nd is the snapshot of what is active on GitLab.com.

[releases handbook page]: https://about.gitlab.com/handbook/engineering/releases/
[gitlab]: https://gitlab.com/gitlab-org/gitlab
[gitaly]: https://gitlab.com/gitlab-org/gitaly
[omnibus-gitlab]: https://gitlab.com/gitlab-org/omnibus-gitlab
